# sushy.oem.dell.resources.manager package

## Submodules

## sushy.oem.dell.resources.manager.constants module

class sushy.oem.dell.resources.manager.constants.ExportTarget(*values)

  Bases: `Enum`

  Export system config action constants

  ALL = 'ALL'

    Export entire system configuration

  BIOS = 'BIOS'

    Export BIOS related configuration

  IDRAC = 'IDRAC'

    Export iDRAC related configuration

  NIC = 'NIC'

    Export NIC related configuration

  RAID = 'RAID'

    Export RAID related configuration

class sushy.oem.dell.resources.manager.constants.ExportUse(*values)

  Bases: `Enum`

  ExportUse in ExportSystemConfiguration

  CLONE = 'Clone'

    Clone export type suitable for cloning a ‘golden’ configuration.

    Compared to Default export type, more attributes are enabled and storage settings adjusted to aid in cloning process.

  DEFAULT = 'Default'

    Default export type

    Leaves some attributes commented out and requires user to enable them before they can be applied during import.

  REPLACE = 'Replace'

    Replace export type suited for replacing complete configuration.

    Compared to Clone export type, most attributes are enabled and storage settings adjusted to aid in the replace process.

class sushy.oem.dell.resources.manager.constants.IncludeInExport(*values)

  Bases: `Enum`

  IncludeInExport in ExportSystemConfiguration

  DEFAULT = 'Default'

    Default for what to include in export.

    Does not include read-only attributes, and depending on Export Use, passwords are marked as ** (for Default) or are set to default password values (for Clone and Replace).

  PASSWORD_HASHES = 'IncludePasswordHashValues'

    Include password hashes.

    When using Clone or Replace, include password hashes, instead of default password. Can be used to replicate passwords across systems.

  READ_ONLY = 'IncludeReadOnly'

    Includes read-only attributes.

    In addition to values included by Default option, this also includes read-only attributes that cannot be changed via Import and are provided for informational purposes only.

  READ_ONLY_PASSWORD_HASHES = 'IncludeReadOnly,IncludePasswordHashValues'

    Includes both read-only attributes and password hashes.

    INCLUDE_EXPORT_READ_ONLY and INCLUDE_EXPORT_PASSWORD_HASHES combined

class sushy.oem.dell.resources.manager.constants.ResetType(*values)

  Bases: `Enum`

  iDRAC Reset reset type constants

  FORCE = 'Force'

    Perform an immediate (non-graceful) shutdown, followed by a restart

  GRACEFUL = 'Graceful'

    Perform a graceful shutdown followed by a restart of the system

class sushy.oem.dell.resources.manager.constants.ShutdownType(*values)

  Bases: `Enum`

  ImportSystemConfiguration ShutdownType values

  FORCED = 'Forced'

    Forced shutdown for Import System Configuration

    The host server will be powered off immediately. Should be used when it is safe to power down the host.

  GRACEFUL = 'Graceful'

    Graceful shutdown for Import System Configuration

    Will wait for the host up to 5 minutes to shut down before timing out. The operating system can potentially deny or ignore the graceful shutdown request.

  NO_REBOOT = 'NoReboot'

    No reboot for Import System Configuration

    No shutdown performed. Explicit reboot is necessary to apply changes.

## sushy.oem.dell.resources.manager.idrac_card_service module

class sushy.oem.dell.resources.manager.idrac_card_service.ActionsField(*args, **kwargs)

  Bases: `CompositeField`

  get_kvm_session = <sushy.resources.common.ActionField object>
  reset_idrac = <sushy.oem.dell.resources.manager.idrac_card_service.ForceActionField object>

class sushy.oem.dell.resources.manager.idrac_card_service.DelliDRACCardService(connector, identity, redfish_version=None, registries=None)

  Bases: `ResourceBase`

  get_allowed_reset_idrac_values()

    Get the allowed values for resetting the idrac.

    Returns:

      A set of allowed values.

  get_kvm_session()

    Get temporary credentials for KVM session

    The TempUsername and TempPassword fields can be used in the following url template: https://{host}/console?username={}&tempUsername={}&tempPassword={} The username is the user used to generate these session-credentials.

    Returns:

      Dict with the fields TempUsername and TempPassword as strings None, if the API did not return any credentials, but did not raise an error. When and why that should happen is unclear, but specified in the API doc.

  identity = <sushy.resources.base.Field object>
  reset_idrac()

    Reset the iDRAC.

class sushy.oem.dell.resources.manager.idrac_card_service.ForceActionField(*args, **kwargs)

  Bases: `CompositeField`

  allowed_values = <sushy.resources.base.Field object>
  target_uri = <sushy.resources.base.Field object>

## sushy.oem.dell.resources.manager.job_collection module

class sushy.oem.dell.resources.manager.job_collection.DellJobCollection(connector, identity, redfish_version=None, registries=None)

  Bases: `ResourceBase`

  get_unfinished_jobs()

    Get the unfinished jobs.

    Returns:

      A list of unfinished jobs.

## sushy.oem.dell.resources.manager.job_service module

class sushy.oem.dell.resources.manager.job_service.ActionsField(*args, **kwargs)

  Bases: `CompositeField`

  delete_job_queue = <sushy.resources.common.ActionField object>

class sushy.oem.dell.resources.manager.job_service.DellJobService(connector, identity, redfish_version=None, registries=None)

  Bases: `ResourceBase`

  delete_jobs(job_ids=['JID_CLEARALL'])

    Delete the given jobs, or all jobs.

    Parameters:

      job_ids – a list of job ids to delete. Clearing all the jobs may be accomplished using the keyword JID_CLEARALL as the job_id.

  identity = <sushy.resources.base.Field object>

## sushy.oem.dell.resources.manager.lifecycle_service module

class sushy.oem.dell.resources.manager.lifecycle_service.ActionsField(*args, **kwargs)

  Bases: `CompositeField`

  remote_service_api_status = <sushy.resources.common.ActionField object>

class sushy.oem.dell.resources.manager.lifecycle_service.DellLCService(connector, identity, redfish_version=None, registries=None)

  Bases: `ResourceBase`

  identity = <sushy.resources.base.Field object>
  is_idrac_ready()

    Indicates if the iDRAC is ready to accept commands.

    Returns:

      A boolean value True/False based on remote service api status response.

  is_realtime_ready()

    Indicates if real-time operations are ready to be accepted.

    Returns:

      True if ready to accept real-time operations, otherwise false.

## sushy.oem.dell.resources.manager.manager module

class sushy.oem.dell.resources.manager.manager.DellManagerActionsField(*args, **kwargs)

  Bases: `CompositeField`

  export_system_configuration = <sushy.oem.dell.resources.manager.manager.ExportActionField object>
  import_system_configuration = <sushy.oem.dell.resources.manager.manager.ImportActionField object>

class sushy.oem.dell.resources.manager.manager.DellManagerExtension(connector, path='', redfish_version=None, registries=None, reader=None, root=None)

  Bases: `OEMResourceBase`

  ACTION_DATA = {'ImportBuffer': None, 'ShareParameters': {'Target': ['ALL']}}
  IDRAC_CONFIG_CD = '<SystemConfiguration><Component FQDD="%s"><Attribute Name="ServerBoot.1#BootOnce">%s</Attribute><Attribute Name="ServerBoot.1#FirstBootDevice">VCD-DVD</Attribute></Component></SystemConfiguration>'
  IDRAC_CONFIG_FLOPPY = '<SystemConfiguration><Component FQDD="%s"><Attribute Name="ServerBoot.1#BootOnce">%s</Attribute><Attribute Name="ServerBoot.1#FirstBootDevice">VFDD</Attribute></Component></SystemConfiguration>'
  IDRAC_MEDIA_TYPES = {VirtualMediaType.CD: '<SystemConfiguration><Component FQDD="%s"><Attribute Name="ServerBoot.1#BootOnce">%s</Attribute><Attribute Name="ServerBoot.1#FirstBootDevice">VCD-DVD</Attribute></Component></SystemConfiguration>', VirtualMediaType.FLOPPY: '<SystemConfiguration><Component FQDD="%s"><Attribute Name="ServerBoot.1#BootOnce">%s</Attribute><Attribute Name="ServerBoot.1#FirstBootDevice">VFDD</Attribute></Component></SystemConfiguration>'}
  RETRY_COUNT = 35
  RETRY_DELAY = 15
  property attributes
  export_system_configuration(include_destructive_fields=True)

    Export system configuration.

    Exports ALL targets for cloning and includes password hashes and read-only attributes.

    Parameters:

      include_destructive_fields – Whether includes settings such as iDRAC static IP address that could lead to losing access to iDRAC if importing this configuration into another system. Default to True for backward compatibility. False recommended if unsure.

    Returns:

      Response object containing configuration details.

    Raises:

      InvalidParameterValueError on invalid target.

    Raises:

      ExtensionError on failure to perform requested operation

  property export_system_configuration_uri
  get_allowed_export_target_values()

    Get the allowed targets of export system configuration.

    Returns:

      A set of allowed values.

  get_allowed_export_use_values()

    Get allowed export use values of export system configuration.

    Returns:

      A set of allowed export use values.

  get_allowed_import_shutdown_type_values()

    Get the allowed shutdown types of import system configuration.

    Returns:

      A set of allowed shutdown type values.

  get_allowed_include_in_export_values()

    Get allowed include in export values of export system configuration.

    Returns:

      A set of allowed include in export values.

  get_pxe_port_macs_bios(ethernet_interfaces_mac)

    Get a list of pxe port MAC addresses for BIOS.

    Parameters:

      ethernet_interfaces_mac – Dictionary of ethernet interfaces.

    Returns:

      List of pxe port MAC addresses.

    Raises:

      ExtensionError on failure to perform requested operation.

  property idrac_card_service

    Reference to DelliDRACCardService instance of this manager.

  import_system_configuration(import_buffer)

    Imports system configuration.

    Caller needs to handle system reboot separately.

    Parameters:

      import_buffer – Configuration data to be imported.

    Returns:

      Task monitor instance to watch for task completion

  property import_system_configuration_uri
  property job_collection

    Property to reference DellJobService instance of this manager.

  property job_service

    Property to reference DellJobService instance of this manager.

  property lifecycle_service

    Property to reference DellLCService instance of this manager.

  reset_idrac(wait=True, ready_wait_time=60)

    Reset the iDRAC and wait for it to become ready.

    Parameters:

      - wait – Whether to return immediately or wait for iDRAC to become operational.

      - ready_wait_time – Amount of time in seconds to wait before starting to check on the iDRAC’s status.

  set_virtual_boot_device(device, persistent=False, manager=None, system=None)

    Set boot device for a node.

    Dell iDRAC Redfish implementation does not support setting boot device to virtual media via standard Redfish means. However, this still can be done via an OEM extension.

    Parameters:

      - device – Boot device. Values are vendor-specific.

      - persistent – Whether to set next-boot, or make the change permanent. Default: False.

      - manager – Manager of OEM extension. Optional.

      - system – System of OEM extension. Optional.

    Raises:

      InvalidParameterValue if Dell OEM extension can’t be used.

    Raises:

      ExtensionError on failure to perform requested operation.

class sushy.oem.dell.resources.manager.manager.ExportActionField(*args, **kwargs)

  Bases: `ActionField`

  allowed_export_use_values = <sushy.resources.base.Field object>
  allowed_include_in_export_values = <sushy.resources.base.Field object>
  shared_parameters = <sushy.oem.dell.resources.manager.manager.SharedParameters object>

class sushy.oem.dell.resources.manager.manager.ImportActionField(*args, **kwargs)

  Bases: `ActionField`

  allowed_shutdown_type_values = <sushy.resources.base.Field object>

class sushy.oem.dell.resources.manager.manager.SharedParameters(*args, **kwargs)

  Bases: `CompositeField`

  allowed_target_values = <sushy.resources.base.Field object>

sushy.oem.dell.resources.manager.manager.get_extension(*args, **kwargs)

## Module contents

this page last updated: 2026-01-20 23:50:10

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.